%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

%global python2_version 2.6
%global with_python3 0
%global pname testify
%else
%global with_python3 0
%global pname testify
%endif

%if 0%{?fedora}
%global with_python3 1
%global pname testify
%endif

Name:           python-testify
Version:        0.11.0
Release:        4%{?dist}
Summary:        A replacement for Python's unittest module and nose

Group:          Development/Languages
License:        ASL 2.0
URL:            https://github.com/Yelp/Testify
Source0:        https://github.com/Yelp/Testify/archive/%{version}.tar.gz#/Testify-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  python-mock
BuildRequires:  python-six

%if 0%{?fedora} || 0%{?rhel} >= 7
BuildRequires:  python-flake8
Requires:       python-flake8
%endif

Requires:       python-six
Requires:       python-mock
Requires:       python-sqlalchemy
Requires:       python-tornado
Requires:       PyYAML

%description
Testify is a replacement for Python's unittest module and nose. It is
modeled after unittest, and existing unittest classes are fully supported.

However, Testify has features above and beyond unittest, including:
 - Class-level setup and tear-down fixture methods, which are run only once
   for an entire class of test methods.
 - A decorator-based approach to fixture methods, enabling features like
   lazily-evaluated attributes and context managers for tests.
 - Enhanced test discovery. Testify can drill down into packages to find
   test cases (similar to nose).
 - Support for detecting and running test suites, grouped by modules, classes,
   or individual test methods.
 - Support for splitting up tests into buckets for multiprocessing.
 - Pretty test runner output.
 - Extensible plugin system for adding additional functionality around
   reporting.
 - Comes complete with other handy testing utilities, including turtle (for
   mocking), code coverage integration, profiling, and numerous common
   assertion helpers for easier debugging.
 - More Pythonic naming conventions.

%package -n python2-%{pname}
Summary: A replacement for Python's unittest module and nose
%{?python_provide:%python_provide python2-%{pname}}

%description -n python2-%{pname}
%{summary}.

%if 0%{?with_python3}
%package -n python3-%{pname}
Summary: A replacement for Python's unittest module and nose

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-flake8
BuildRequires:  python3-mock
BuildRequires:  python3-six

Requires:       python3-mock
Requires:       python3-six
Requires:       python3-sqlalchemy
Requires:       python3-tornado
Requires:       python3-PyYAML

%description -n python3-%{pname}
%{summary}.
%endif # with_python3


%prep
%setup -qc

mv Testify-%{version} python2

%if 0%{?with_python3}
cp -a python2 python3
%endif # with_python3

%build
pushd python2
%{__python2} setup.py build --executable="%{__python2} -s"
popd

%if 0%{?with_python3}
pushd python3
%{__python3} setup.py build --executable="%{__python3} -s"
popd
%endif

%install
%if 0%{?with_python3}
pushd python3
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}

mv %{buildroot}%{_bindir}/testify %{buildroot}%{_bindir}/python%{python3_version}-testify

for i in testify-3 testify-%{python3_version}; do
  ln -fs %{_bindir}/python%{python3_version}-testify %{buildroot}%{_bindir}/$i
done
popd
%endif

pushd python2
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

mv %{buildroot}%{_bindir}/testify %{buildroot}%{_bindir}/python%{python2_version}-testify

for i in testify testify-2 testify-%{python2_version}; do
  ln -fs %{_bindir}/python%{python2_version}-testify %{buildroot}%{_bindir}/$i
done
popd

%if 0%{?fedora} || 0%{?rhel} >= 7
%check
pushd python2
export PYTHONPATH=%{buildroot}%{python2_sitelib}:%{python2_sitelib}
%{__python2} test/test_case_test.py
popd

%if 0%{?with_python3}
pushd python3
export PYTHONPATH=%{buildroot}%{python3_sitelib}:%{python3_sitelib}
%{__python3} test/test_case_test.py
popd
%endif
%endif

%files -n python2-%{pname}
%doc python2/README.md
%license python2/LICENSE.txt
%{python2_sitelib}/*egg-info
%{python2_sitelib}/testify/
%{_bindir}/testify
%{_bindir}/testify-2
%{_bindir}/testify-%{python2_version}
%{_bindir}/python%{python2_version}-testify

%if 0%{?with_python3}
%files -n python3-%{pname}
%doc python3/README.md
%license python3/LICENSE.txt
%{python3_sitelib}/*egg-info
%{python3_sitelib}/testify/
%{_bindir}/testify-3
%{_bindir}/testify-%{python3_version}
%{_bindir}/python%{python3_version}-testify
%endif

%changelog
* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.11.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com> - 0.11.0-3
- Rebuild for Python 3.6

* Wed Aug 17 2016 Antonio Trande <sagitter@fedoraproject.org> - 0.11.0-2
- Rebuild for Python 3.5.2

* Thu Aug 04 2016 Antonio Trande <sagitter@fedoraproject.org> - 0.11.0-1
- Update to 0.11.0

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.3-3
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon Jun 06 2016 Antonio Trande <sagitter@fedoraproject.org> - 0.8.3-2
- Tests disabled on epel6 (flake8 missing)

* Sun Jun 05 2016 Antonio Trande <sagitter@fedoraproject.org> - 0.8.3-1
- Update to 0.8.3
- Make a Python3 package

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jun 22 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.4.0-2
- fix non-executable-script warnings

* Wed Jun 19 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.4.0-1
- update to upstream release 0.4.0
- remove redundant build variables
- add man page based on output from help2man

* Sat Mar 09 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.3.10-1
- initial package
